import express,{Router, Request, Response} from 'express';
import {User} from '../models/User';
// import {DataSource} from 'typeorm';
import {myDataSource} from '../app-data-source';

const router:Router = express.Router();
const dataSource = myDataSource;

router.get('/', async (req : Request, res : Response):Promise<object> => {
const users:any = await dataSource.manager.find(User)
return res.send({users})
})


router.post('/', async (req : Request, res : Response):Promise<object> => {
    const {name,surname,password,email} = req.body;
    const displayName = surname+' '+name[0]+'.'
    const user = new User();
    user.name = name;
    user.surname = surname;
    user.password = password;
    user.displayName= displayName;
    user.email = email;
    await user.save();
    return res.send({user})
})




// router.post('/', async (req : Request, res : Response) => {
//     try{
//     const {name,surname,password,email} = req.body;
//     const displayName = surname+' '+name[0]+'.'
//     await User.insert({
//         name:name,
//         surname:surname,
//         email:email,
//         password:password,
//         displayName:displayName
//     })
    // const user:User = new User({
    //     name:name,
    //     surname:surname,
    //     email:email,
    //     password:password,
    //     displayName:displayName
    // })
    // await user.save();
//     return res.send({message:'created user'})
// }catch(e ){
//     if (e instanceof Error){
//         return res.status(404).send({'message':e.message});
//     }
//     return res.status(500).send({'message':'Broke server'});
// }
// })


// router.get('/', async (req : Request, res : Response):Promise<Response<any, Record<string, any>>> => {
//     const users = await User.find()
//     return res.send({users})
// })

export default router;
